package com.farecompare.jboss7example.client;

import com.farecompare.jboss7example.relay.api.RelayModuleAPI;
import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;

import javax.naming.Context;
import javax.naming.InitialContext;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.Hashtable;
import java.util.Properties;

/**
 * Created by IntelliJ IDEA.
 * User: graemewallace
 * Date: 5/8/12
 * Time: 2:33 PM
 * To change this template use File | Settings | File Templates.
 */
public class ClientApp {

    public static void main(String [] args) throws Exception {
        Properties properties = new Properties();

        properties.put("endpoint.name", "farecompare-client-endpoint");
        properties.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");

        properties.put("remote.connections", "cmc5104");
        properties.put("remote.connection.cmc5104.host", "localhost");
        properties.put("remote.connection.cmc5104.port", "4447");
        properties.put("remote.connection.cmc5104.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");

        PropertiesBasedEJBClientConfiguration configuration = new PropertiesBasedEJBClientConfiguration(properties);

        final ContextSelector<EJBClientContext> ejbClientContextSelector = new ConfigBasedEJBClientContextSelector(configuration);

        final ContextSelector<EJBClientContext> previousSelector = EJBClientContext.setSelector(ejbClientContextSelector);

        final Hashtable jndiProperties = new Hashtable();
        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");

        final Context context = new InitialContext(jndiProperties);

        //ejb:<app-name>/<module-name>/<distinct-name>/<bean-name>!<fully-qualified-classname-of-the-remote-interface>
        RelayModuleAPI relayModule = (RelayModuleAPI) context.lookup(
  "ejb:relaymodule/farecompare-relaymodule//RelayModuleSessionBean!com.farecompare.jboss7example.relay.api.RelayModuleAPI");

        LineNumberReader lReader = new LineNumberReader(new InputStreamReader(System.in));

        for (;;) {
            System.out.print("City Code: "); System.out.flush();
            String cityCode = lReader.readLine();

            String cityLocation = relayModule.getNameForCityCode(cityCode);

            System.out.println(cityLocation);
        }
    }

}
